%global with_python3 1
%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print (get_python_lib(1))")}



%define libsepolver 2.5
%define libselinuxver 2.5


Summary: 	SELinux binary policy manipulation library
Name: 		libsemanage
Version: 	2.5
Release: 	%mkrel 6
License: 	GPLv2+
Group: 		System/Libraries
URL:		http://www.selinuxproject.org
Source0: 	https://raw.githubusercontent.com/wiki/SELinuxProject/selinux/files/releases/20160223/libsemanage-%version.tar.gz
Source1: 	semanage.conf
Patch1:         libsemanage-fedora.patch
BuildRequires: 	bison
BuildRequires: 	flex
BuildRequires: 	selinux-devel  >= %{libselinuxver}
BuildRequires: 	sepol-devel >= %{libsepolver}
BuildRequires: 	ustr-static-devel
BuildRequires:  python-devel
BuildRequires: 	bzip2-devel
BuildRequires:  audit-devel
BuildRequires:	swig

%if 0%{?with_python3}
BuildRequires:  python3 
BuildRequires:  python3-devel
%endif # if with_python3


%description
Security-enhanced Linux is a feature of the Linux® kernel and a number
of utilities with enhanced security functionality designed to add
mandatory access controls to Linux.  The Security-enhanced Linux
kernel contains new architectural components originally developed to
improve the security of the Flask operating system. These
architectural components provide general support for the enforcement
of many kinds of mandatory access control policies, including those
based on the concepts of Type Enforcement®, Role-based Access
Control, and Multi-level Security.

libsemanage provides an API for the manipulation of SELinux binary policies.
It is used by checkpolicy (the policy compiler) and similar tools, as well
as by programs like load_policy that need to perform specific transformations
on binary policies such as customizing policy boolean settings.

%package -n %{mklibname semanage 1}
Summary: 	SELinux binary policy manipulation library
Group: 		System/Libraries
Provides: 	semanage = %{version}-%{release}

%description -n %{mklibname semanage 1}
libsemanage provides an API for the manipulation of SELinux binary policies.
It is used by checkpolicy (the policy compiler) and similar tools, as well
as by programs like load_policy that need to perform specific transformations
on binary policies such as customizing policy boolean settings.

%package -n %{mklibname semanage -d}
Summary: 	Header files and libraries used to build policy manipulation tools
Group: 		Development/C
Requires: 	%{mklibname semanage 1} = %{version}-%{release}
Provides: 	semanage-devel = %{version}-%{release}
Obsoletes: 	%{mklibname semanage 1 -d}

%description -n %{mklibname semanage -d}
The libsemanage-devel package contains the libraries and header files
needed for developing applications that manipulate binary policies.

%package -n %{mklibname semanage -d -s}
Summary: 	Static libraries used to build policy manipulation tools
Group: 		Development/C
Requires: 	%{mklibname semanage -d} = %{version}-%{release}
Provides: 	semanage-static-devel = %{version}-%{release}
Obsoletes: 	%{mklibname semanage 1 -d -s}

%description -n %{mklibname semanage -d -s}
The libsemanage-devel package contains the static libraries
needed for developing applications that manipulate binary policies.

%package python
Summary: 	semanage python bindings for %{name}
Group: 		Development/Python
Requires:       semanage = %{version}-%{release}
Requires:       libselinux-python
Provides: 	semanage-python = %{version}-%{release}
## This line could be removed before the release of mga6
## It's needed to remove wrongly name packages
Obsoletes:	python-semanage

%description python
This package contains python bindings for %{name}.

%if 0%{?with_python3}
%package python3
Summary: 	Python bindings for %{name}
Group: 		Development/Python
Requires:       semanage = %{version}-%{release}
Requires:       libselinux-python3
Provides: 	semanage-python3 = %{version}-%{release}
## This line could be removed before the release of mga6
## It's needed to remove wrongly name packages
Obsoletes:	python3-semanage


%description python3
The libsemanage-python3 package contains the python 3 bindings for developing
SELinux management applications.
%endif # if with_python3

%prep
%setup -q
%autopatch -p1

%build
export LDFLAGS="%{?__global_ldflags}"

# To support building the Python wrapper against multiple Python runtimes
# Define a function, for how to perform a "build" of the python wrapper against
# a specific runtime:
BuildPythonWrapper() {
  BinaryName=$1

  # Perform the build from the upstream Makefile:
  make \
    PYTHON=$BinaryName \
    CFLAGS="%{optflags}" LIBDIR="%{_libdir}" SHLIBDIR="%{_lib}" \
    pywrap
}

make clean
make CFLAGS="%{optflags}" swigify
make CFLAGS="%{optflags}" LIBDIR="%{_libdir}" SHLIBDIR="%{_lib}" all

BuildPythonWrapper \
  %{__python}
  
%if 0%{?with_python3}
BuildPythonWrapper \
  %{__python3}
%endif # with_python3

%install
InstallPythonWrapper() {
  BinaryName=$1

  make \
    PYTHON=$BinaryName \
    DESTDIR="%{buildroot}" LIBDIR="%{buildroot}%{_libdir}" SHLIBDIR="%{buildroot}/%{_libdir}" \
    install-pywrap
}

rm -rf %{buildroot}
mkdir -p %{buildroot}%{_libdir}
mkdir -p %{buildroot}%{_includedir} 
mkdir -p %{buildroot}%{buildroot}%{_sharedstatedir}/selinux
mkdir -p %{buildroot}%{buildroot}%{_sharedstatedir}/selinux/tmp
make DESTDIR="%{buildroot}" LIBDIR="%{buildroot}%{_libdir}" SHLIBDIR="%{buildroot}/%{_libdir}" install

InstallPythonWrapper \
  %{__python} \
  .so

%if 0%{?with_python3}
InstallPythonWrapper \
  %{__python3} \
  $(python3-config --extension-suffix)
%endif # with_python3
  
cp %{SOURCE1} %{buildroot}/etc/selinux/semanage.conf
ln -sf  %{_libdir}/libsemanage.so.1 %{buildroot}/%{_libdir}/libsemanage.so


%files -n %{mklibname semanage 1}
%config(noreplace) /etc/selinux/semanage.conf
%{_libdir}/libsemanage.so.1

%files -n %{mklibname semanage -d -s}
%{_libdir}/libsemanage.a


%files -n %{mklibname semanage -d}
%{_libdir}/libsemanage.so
%{_libdir}/pkgconfig/libsemanage.pc
%{_includedir}/semanage
%{_mandir}/man3/*
%{_mandir}/man5/*

%files  python
%{python_sitearch}/_semanage.so
%{python_sitearch}/semanage.py*


%if 0%{?with_python3}
%files  python3
%{python3_sitearch}/*.so
%{python3_sitearch}/semanage.py*
%{python3_sitearch}/__pycache__/semanage*
%{_libexecdir}/selinux/semanage_migrate_store
%endif # if with_python3




%changelog
* Fri Mar 04 2016 spuhler <spuhler> 2.5-6.mga6
+ Revision: 985710
- added Provides

* Fri Mar 04 2016 spuhler <spuhler> 2.5-5.mga6
+ Revision: 985658
- bumped rel for rebuild

* Thu Mar 03 2016 spuhler <spuhler> 2.5-4.mga6
+ Revision: 985232
- fixed Require name on the python packages

* Thu Mar 03 2016 spuhler <spuhler> 2.5-3.mga6
+ Revision: 985059
- obsoletet orphan packages (that are in cauldron only)

* Wed Mar 02 2016 spuhler <spuhler> 2.5-2.mga6
+ Revision: 983469
- renamed python packages

* Mon Feb 29 2016 spuhler <spuhler> 2.5-1.mga6
+ Revision: 980907
- missing Buildrequires
- added python3
  * synced spec with Fedora
- upgrade to vers 2.5

  + umeabot <umeabot>
    - Mageia 6 Mass Rebuild

  + tv <tv>
    - bump needed libsepol version
    - new release
    - fix source URL
    - new release

* Wed Oct 15 2014 umeabot <umeabot> 2.3-4.mga5
+ Revision: 744089
- Second Mageia 5 Mass Rebuild

* Sat Sep 27 2014 tv <tv> 2.3-3.mga5
+ Revision: 726874
- rebuild for missing pythoneggs deps

* Tue Sep 16 2014 umeabot <umeabot> 2.3-2.mga5
+ Revision: 681775
- Mageia 5 Mass Rebuild

* Mon Jun 16 2014 spuhler <spuhler> 2.3-1.mga5
+ Revision: 636880
+ rebuild (emptylog)

* Sat May 31 2014 pterjan <pterjan> 2.2-2.mga5
+ Revision: 628309
- Rebuild for new Python

* Thu Feb 06 2014 spuhler <spuhler> 2.2-1.mga5
+ Revision: 584097
- added BuildRequires: audit-devel
- upgrade to ver 2.2

* Sat Oct 19 2013 umeabot <umeabot> 2.1.10-2.mga4
+ Revision: 522499
- Mageia 4 Mass Rebuild

* Wed Mar 06 2013 spuhler <spuhler> 2.1.10-1.mga3
+ Revision: 401552
- update to 2.1.10
 * Add sefcontext_compile to compile regex everytime policy is rebuilt
 * Cleanup/fix enable/disable/remove module.
 * redo genhomedircon minuid
 * fixes from coverity
 * semanage_store: do not leak memory in semanage_exec_prog
 * genhomedircon: remove useless conditional in get_home_dirs
 * genhomedircon: double free in get_home_dirs
 * fcontext_record: do not leak on error in semanage_fcontext_key_create
 * genhomedircon: do not leak on failure in write_gen_home_dir_context
 * semanage_store: do not leak fd
 * genhomedircon: do not leak shells list
 * semanage_store: do not leak on strdup failure
 * semanage_store: rewrite for readability
- updated to new Fedora patch

* Sat Jan 12 2013 umeabot <umeabot> 2.1.9-2.mga3
+ Revision: 358138
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Dec 02 2012 spuhler <spuhler> 2.1.9-1.mga3
+ Revision: 325064
- upgrade to 2.1.9
- added semannage.conf

* Mon Sep 03 2012 spuhler <spuhler> 2.1.8-2.mga3
+ Revision: 287751
- rebuild due to a missing pkgs

* Sun Sep 02 2012 spuhler <spuhler> 2.1.8-1.mga3
+ Revision: 287380
- added BuildRequires: swig
- upgrade to 2.1.8

* Fri Feb 11 2011 dmorgan <dmorgan> 2.0.31-3.mga1
+ Revision: 50030
- Remove mdv macros
- imported package libsemanage


* Sat Nov 06 2010 Funda Wang <fwang@mandriva.org> 2.0.31-3mdv2011.0
+ Revision: 593901
- rebuild for py2.7

* Sun Sep 13 2009 Thierry Vignaud <tv@mandriva.org> 2.0.31-2mdv2010.0
+ Revision: 438738
- rebuild

* Fri Jan 23 2009 Jérôme Soyer <saispo@mandriva.org> 2.0.31-1mdv2009.1
+ Revision: 332745
- New upstream release
- New upstream release

* Mon Jan 05 2009 Jérôme Soyer <saispo@mandriva.org> 2.0.30-1mdv2009.1
+ Revision: 325054
- New upstream release

* Sun Jan 04 2009 Funda Wang <fwang@mandriva.org> 2.0.29-2mdv2009.1
+ Revision: 324119
- rebuild

* Sun Nov 30 2008 David Walluck <walluck@mandriva.org> 2.0.29-1mdv2009.1
+ Revision: 308329
- 2.0.29

* Mon Nov 24 2008 David Walluck <walluck@mandriva.org> 2.0.28-1mdv2009.1
+ Revision: 306133
- 2.0.28

* Sun Aug 17 2008 David Walluck <walluck@mandriva.org> 2.0.27-2mdv2009.0
+ Revision: 273019
- Provides: semanage = %%{version}-%%{release}

* Sun Aug 17 2008 David Walluck <walluck@mandriva.org> 2.0.27-1mdv2009.0
+ Revision: 272849
- 2.0.27

* Sat Aug 16 2008 David Walluck <walluck@mandriva.org> 2.0.25-1mdv2009.0
+ Revision: 272747
- 2.0.25

* Sun Jul 27 2008 Thierry Vignaud <tv@mandriva.org> 2.0.9-4mdv2009.0
+ Revision: 250480
- rebuild

  + Pixel <pixel@mandriva.com>
    - do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Wed Jan 02 2008 David Walluck <walluck@mandriva.org> 2.0.9-2mdv2008.1
+ Revision: 140336
- add proper python package

* Wed Jan 02 2008 David Walluck <walluck@mandriva.org> 2.0.9-1mdv2008.1
+ Revision: 140313
- add python requires
- BuildRequires: flex
- BuildRequires: bison
- import libsemanage


